{

ValueMonitor, sits in the background and monitors global variables, printing the values to a serial terminal at 19200 baud. Ver.1
TO BE: support for n number of varables, and support for display texts defined in DAT
Erlend Fjosna 2013
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
A pointer to a block of LONG is passed as parameter, together with the number of LONGs to read from that block. The method continously reads these varaiables and
displays them on a serial terminal.

-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 Acknowledements
 Chris Gadd kindly shared the bare bone code for this monitor.



=======================================================================================================================================================================
=======================================================================================================================================================================
}

CON
        _clkmode = xtal1 + pll16x                                              
        _xinfreq = 5_000_000

VAR        
          long  monitorStack[128]

          
PUB start(intLong0{ptr}, intLongN)

    cognew(monitor(intLong0{ptr}, intLongN), @monitorStack)

{need a stop + pluss a stop call}


PUB monitor(intLong0{ptr}, intLongN) | pm

  dira[30]~~

  repeat
    waitcnt(cnt + clkfreq / 3)
    Tx($00)
    str(string("Water level [mm]: "))
    pm:= LONG[intLong0] [0]         
    Dec(pm)                      
    str(string($0D,"Water temp [C]: "))
    pm:= LONG[intLong0] [1]      
    Dec(pm)
        str(string($0D,"Water pressure [cBar]: "))
    pm:= LONG[intLong0] [2]      
    Dec(pm)
        str(string($0D,"Light int.[%]: "))
    pm:= LONG[intLong0] [3]      
    Dec(pm)
          str(string($0D,"Weight [g]: "))
    pm:= LONG[intLong0] [4]      
    Dec(pm)                                          
          str(string($0D,"Voltage [cV]: "))
    pm:= LONG[intLong0] [5]      
    Dec(pm)
          str(string($0D,"adc: "))
    pm:= LONG[intLong0] [6]      
    Dec(pm)                                          
          str(string($0D,"adc "))
    pm:= LONG[intLong0] [7]      
    Dec(pm)
              str(string($0D,"HWC "))
    pm:= LONG[intLong0] [8]      
    Dec(pm)
              str(string($0D,"QUAD "))
    pm:= LONG[intLong0] [9]      
    Dec(pm)
                  str(string($0D,"RFID "))
    pm:= LONG[intLong0] [10]      
    Dec(pm)

                      str(string($0D,"OutA "))               'NEW
    pm:= LONG[intLong0] [11]      
    Dec(pm)
                      str(string($0D,"OutB "))
    pm:= LONG[intLong0] [12]      
    Dec(pm)
                      str(string($0D,"InA "))
    pm:= LONG[intLong0] [13]      
    Bin(pm, 8)
                      str(string($0D,"InB "))
    pm:= LONG[intLong0] [14]      
    Bin(pm, 8)
                      str(string($0D,"Tray "))
    pm:= LONG[intLong0] [15]      
    Bin(pm, 8)
                      str(string($0D,"temp threshold "))
    pm:= LONG[intLong0] [16]      
    Dec(pm)
                      str(string($0D,"Flame "))
    pm:= LONG[intLong0] [17]      
    Dec(pm)
                      str(string($0D,"Heat "))
    pm:= LONG[intLong0] [18]      
    Dec(pm)                                                          
                   

                                  
                            

PRI Str(stringPtr)

  repeat strsize(stringPtr)
    Tx(byte[stringPtr++])                                                       'Transmit each byte in the string

PRI Dec(value) | i, x

  x := value == NEGX                                    'Check for max negative
  if value < 0
    value := ||(value+x)                                'If negative, make positive; adjust for max negative
    Tx("-")                                             'and output sign

  i := 1_000_000_000                                    'Initialize divisor

  repeat 10                                             'Loop for 10 digits
    if value => i                                                               
      Tx(value / i + "0" + x*(i == 1))                  'If non-zero digit, output digit; adjust for max negative
      value //= i                                       'and digit from value
      result~~                                          'flag non-zero found
    elseif result or i == 1
      Tx("0")                                           'If zero digit (or only digit) output it
    i /= 10                                             'Update divisor

PRI Hex(value, digits)

  value <<= (8 - digits) << 2
  Tx("$")
  repeat digits                                         'do it for the number of hex digits being transmitted
    Tx(lookupz((value <-= 4) & $F : "0".."9", "A".."F"))'  Transmit the ASCII value of the hex characters

PRI Bin(value, digits)

  value <<= 32 - digits
  Tx("%")
  repeat digits
    Tx((value <-= 1) & 1 + "0")    
    
PRI Tx(txByte) | t, bit_delay

  bit_delay := clkfreq / 19200

  txByte <<= 2
  t := cnt
  repeat 10
    outa[30] := (txByte >>= 1) & 1
    waitcnt (t += bit_delay)
  outa[30]~~



DAT
DaaaBbbbb    BYTE  "string_data",0        

{{

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and    
associated documentation files (the "Software"), to deal in the Software without restriction,        
including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:                                                                 
                                                                                                     
The above copyright notice and this permission notice shall be included in all copies or substantial 
portions of the Software.                                                                            
                                                                                                     
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER         
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

}}                                    